// THE ENGINE
/*
Book of Shadows 2
2/15/2013
Christopher Franko
BriefCaseIT Network
*/

////////////////////////////////
//   SITE SPINNER
////////////////////////////////

function changePage(id) {
	
		$.mobile.changePage( id, { allowSamePageTransition: true } );
	}
	
 function setCategoryId(cat_id, cat_name)
 	{
		console.log("Local Storage:" + cat_id + ", " + cat_name);
		window.localStorage.setItem("PARENT_CAT_ID", cat_id);
        window.localStorage.setItem("PARENT_CAT_NAME", cat_name);
		
		changePage("#viewCategory");
		
	}
	
	function setPageId(cat_id, page_id, page_name)
 	{
		console.log("Set Local Storage:" + cat_id + ", " + page_name + ", " + page_id);
		
		window.localStorage.setItem("PARENT_CAT_ID", cat_id);
       	window.localStorage.setItem("PAGE_ID", page_id);
		window.localStorage.setItem('PAGE_NAME', page_name);
		
		changePage("#viewPage");
		
	}
	
	function loadPage(tx, rs) {
        var rowOutput = "";
        //var todoItems = document.getElementById("todoItems");
        for (var i=0; i < rs.rows.length; i++) {
          //rowOutput += renderTodo(rs.rows.item(i));
		 $("#DataContainer").html(rs.rows.item(i).content.replace(/\\/g,""));		  
		  
        }
      }
	
 function loadCategory(tx, rs) {
	 $("ul").listview();
		  $.each(rs.rows, function(i, value){
             
		  $("ul").append("<li><a href=\"#\" onclick=\"setCategoryId('" + rs.rows.item(i).cat_id + "','"+ rs.rows.item(i).cat_name +"');\">" + rs.rows.item(i).cat_name + "</a></li>");
		  
		  $("ul").listview("refresh");
		});
      }
	  
	  function loadArticle(tx, rs) {
        
        
        $.each(rs.rows, function(i, value){
         
		  $('#dalist').append("<li><a href=\"#\" onclick=\"setPageId('" + rs.rows.item(i).cat_parent + "','"+ rs.rows.item(i).article_id +"','"+ rs.rows.item(i).article_name +"');\">" + rs.rows.item(i).article_name + "</a></li>");
		  
		  $("#dalist").listview("refresh");
		  
        });
      }
      
      function renderCategory(row) {
        return "<li>" + row.cat_name  + "</li>";
      }
	  
	  function renderArticle(row) {
        return "<li>" + row.article_name  + "</li>";
      }
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// MOB INITILIZE                                                    //
//////////////////////////////////////////////////////////////////////
 $(document).bind("mobileinit", function () {
  $.extend($.mobile, {
    ajaxEnabled: true
  });
////////////////////////////////
// MobileInit             //////
////////////////////////////////
$.mobile.loadingMessageTextVisible = true;
$.mobile.loadingMessage = 'Loading Please Wait..';
$.mobile.defaultPageTransition = 'fade';
});
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// DATABASE & DISPLAY LISTVIEW FUNCTIONS                            //
//////////////////////////////////////////////////////////////////////

  
var html5rocks = {};
html5rocks.webdb = {};
html5rocks.webdb.db = null;
      
      html5rocks.webdb.open = function() {
        var dbSize = 5 * 1024 * 1024; // 5MB
        html5rocks.webdb.db = window.openDatabase("FBOB2", "1.0", "Book of shadows DB", dbSize);
		console.log("opened db");
      }
	  
 html5rocks.webdb.select_cats = function(x)
 {
	 	var db = html5rocks.webdb.db;
		db.transaction(function (tx) {
  			tx.executeSql("SELECT * FROM category WHERE cat_parent = ?",
          	    [x],
          	    html5rocks.webdb.onSuccess,
          	    html5rocks.webdb.onError);
		});	 
 }

  html5rocks.webdb.select_articles = function(x)
 {
	 	var db = html5rocks.webdb.db;
		db.transaction(function (tx) {
  			tx.executeSql("SELECT * FROM article WHERE cat_parent = ?",
          	    [x],
          	    html5rocks.webdb.onSuccess.article,
          	    html5rocks.webdb.onError);
		});	 
 }
      html5rocks.webdb.onError = function(tx, e) {
        alert("There has been an error: " + e.message);
      }
      
      html5rocks.webdb.onSuccess = function(tx, r) {
        // re-render the data.
        html5rocks.webdb.getAllTodoItems(loadTodoItems);
      }
      
	  html5rocks.webdb.onSuccess.article = function(tx, r) {
        // re-render the data.
        html5rocks.webdb.getAllTodoItems.article(loadarticle);
      }
      
      html5rocks.webdb.getAllTodoItems = function(renderFunc, cid) {
        var db = html5rocks.webdb.db;
        db.transaction(function(tx) {
          tx.executeSql("SELECT * FROM category WHERE cat_parent = ?", [cid], renderFunc,
              html5rocks.webdb.onError);
        });
      }
	  
	  html5rocks.webdb.getAllTodoItems.article = function(renderFunc, cid) {
        var db = html5rocks.webdb.db;
        db.transaction(function(tx) {
          tx.executeSql("SELECT * FROM article WHERE cat_parent = ?", [cid], renderFunc,
              html5rocks.webdb.onError);
        });
      }
	  
	  html5rocks.webdb.getPageData = function(renderFunc, pid) {
        var db = html5rocks.webdb.db;
        db.transaction(function(tx) {
          tx.executeSql("SELECT * FROM article WHERE article_id = ?", [pid], renderFunc,
              html5rocks.webdb.onError);
        });
      }
//SET STARTSCREEN EVENTS
$(document).delegate('#start', 'pagebeforeshow', function () {	
    $("#grid1").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '1');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Volume One');					
                    //Navigate to next page
    })
	
	$("#grid2").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '2');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Volume Two');
                    //Navigate to next page
					
    })
	
	$("#grid3").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '3');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Volume Three');
                    //Navigate to next page
					
    })
	
	$("#grid4").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '4');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Book of Enoch');
                    //Navigate to next page
					
    })
	/*
	$("#gridGems").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '5');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Gems');
                    //Navigate to next page
					
    })
	
	$("#gridHerbalism").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '6');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Herbalism');
                    //Navigate to next page
					
    })
	
	$("#gridAstrology").bind('tap',function(event, ui){
        //set window.localStorage variables
                    window.localStorage.setItem('PARENT_CAT_ID', '7');
                    window.localStorage.setItem('PARENT_CAT_NAME', 'Astrology');
                    //Navigate to next page
					
    })
	*/
});
//	create viewCategory
$(document).delegate('#viewCategory', 'pagebeforeshow', function () {	
	//Empty the List
	$('#dalist').empty();
	
	//set the variable
	var headerText = window.localStorage.getItem('PARENT_CAT_NAME');
	//update the header text
	$("#HeaderText").trigger("create");
	//$("#dalist").listview();
	$("#HeaderText").text(headerText);
	//load content
	 var cat_parent_id = window.localStorage.getItem('PARENT_CAT_ID');
	 console.log("CAT_ID = " + cat_parent_id);
	//open db
		html5rocks.webdb.open();  
		//html5rocks.webdb.select_cats(cat_parent_id);
		
		html5rocks.webdb.getAllTodoItems(loadCategory , cat_parent_id);
		//html5rocks.webdb.select_articles(cat_parent_id);
		html5rocks.webdb.getAllTodoItems.article(loadArticle, cat_parent_id);
		
	
});

$(document).delegate('#viewPage', 'pagebeforeshow', function () {	
  //Empty the List

	$('#DataContainer').empty();
	$('#buttonz').empty();
	
	//set the variable
	var ParentName = window.localStorage.getItem('PARENT_CAT_NAME');
	var PageId = window.localStorage.getItem('PAGE_ID');
	var PageName = window.localStorage.getItem('PAGE_NAME');
	
	var PN = ParentName.replace(/ /g,"-").replace(/\\/g,"");
	//update the header text
 
	//set the variable
	var headerText = window.localStorage.getItem('PAGE_NAME');
		
	var siteUrl = "http://master.briefcaseit.com/article/"+PageId+"/"+PN;
	//create social shares
	$('#buttonz').jsShare({ maxwidth: 360, yoursitetitle: PageName, yoursiteurl: siteUrl});
	
	
	//update the header text
	$("#HeaderText2").trigger("create");
	$('#DataContainer').trigger("create");
	//use html and add an image
	//$("#HeaderText").html(headerText);
	$("#HeaderText2").text(headerText);
	
	//load content
	 console.log("PAGE_ID = " + PageId + " PAGE_NAME = " + PageName);
	//open db
		html5rocks.webdb.open();  
		//run load page
		 
		html5rocks.webdb.getPageData(loadPage,PageId);	
		 
	


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//END MOB INITILIZE                                                 //
//////////////////////////////////////////////////////////////////////
});


function fuckSpinners(){
 $("#start").live('pagebeforeshow', function (e, ui) {          
            setTimeout($.mobile.showPageLoadingMsg, 5);                      
});

 $("#start").live('pageshow', function (e, ui) {          
            setTimeout($.mobile.hidePageLoadingMsg, 5);                      
});
 $("#viewCategory").live('pagebeforeshow', function (e, ui) {          
            setTimeout($.mobile.showPageLoadingMsg, 5);                      
});

 $("#viewCategory").live('pageshow', function (e, ui) {          
            setTimeout($.mobile.hidePageLoadingMsg, 5);                      
});	

 $("#viewPage").live('pagebeforeshow', function (e, ui) {          
            setTimeout($.mobile.showPageLoadingMsg, 5);                      
});

 $("#viewPage").live('pageshow', function (e, ui) {          
            setTimeout($.mobile.hidePageLoadingMsg, 5);                      
});
}